package multex;  //MsgTest.java

import multex.test.InitFailure;
import multex.test.MsgTextDeResourceBundle;
import multex.test.TextException3Chain;
import multex.test.NotextException3Chain;

//2003-05-08  Knabe  Aus Vorlage ExceptionChainTest
//2002-05-30  Knabe  Umbau von Stack_bt gem Beispiel junit.samples.VectorTest

/**JUnit batch test driver for the class multex.Msg.
*/
public class MsgTest extends junit.framework.TestCase {


//Verwaltungsoperationen:

public MsgTest(String name) {
  super(name);
}
public static void main (String[] args) {
  junit.textui.TestRunner.run(suite());
}
public static junit.framework.Test suite() {
  final junit.framework.TestSuite result
  = new junit.framework.TestSuite(MsgTest.class);
  return result;
}

//Einzelne Testschritte:

/**Tests printing messages for a chain of exceptions without any associated message texts
*/
public void testPrintMessages_withoutAnyText(){
	final Throwable ex1 = NotextException3Chain.construct();
	
	
	final StringBuffer buf = new StringBuffer();
	Msg.printMessages(buf, ex1);
    final String result = buf.toString();
    assertEquals(
        ex1.getClass().getName()
        + _lineSeparator + MsgText.causeMarker
        + NotextException3Chain.ex2Name
        + _lineSeparator + MsgText.causeMarker
        + NotextException3Chain.ex3Message
        , result
    ); 	
}

/**Tests printing the default messages for the exception chain {@link Exception3Chain}.
*/
public void testPrintMessages_defaultTextFromExceptionObject(){
	final Throwable ex1 = TextException3Chain.construct();
	
	final StringBuffer buf = new StringBuffer();
	Msg.printMessages(buf, ex1);
    final String result = buf.toString();
    
    assertEquals(
      InitFailure.cannotInitObject + TextException3Chain.ex1Object 
      + InitFailure.withValue + TextException3Chain.ex1Value + InitFailure.dot
      + _lineSeparator + MsgText.causeMarker
      + TextException3Chain.couldNotLoadDiagram + TextException3Chain.diagramName + TextException3Chain.fromFile + TextException3Chain.fileName
      + _lineSeparator + MsgText.causeMarker
      + TextException3Chain.ex3.getClass().getName() + ": " + TextException3Chain.ex3ClassName
      , result
    );
}

public void testPrintMessages_withResourcebundleText(){
	final StringBuffer buf = new StringBuffer();
	final Throwable ex1 = TextException3Chain.construct();
	final String causeMarker    = "Ursache: ";
	final String lineSeparator = "\n<BR>";
	final MultexLocale locale = new MultexLocale(
	    new multex.test.MsgTextDeResourceBundle(), java.util.Locale.GERMAN, causeMarker
	);
	Msg.printMessages(buf, ex1, locale, lineSeparator);
    final String result = buf.toString();
    
	final String causeSeparator = lineSeparator + causeMarker;
    assertEquals(
      MsgTextDeResourceBundle.wertText + TextException3Chain.ex1Value 
      + MsgTextDeResourceBundle.objektText + TextException3Chain.ex1Object 
      + MsgTextDeResourceBundle.initText
      + causeSeparator
      + TextException3Chain.couldNotLoadDiagram + TextException3Chain.diagramName + TextException3Chain.fromFile + TextException3Chain.fileName
      + causeSeparator
      + MsgTextDeResourceBundle.classCastExceptionText + ": " + TextException3Chain.ex3ClassName
      , result
    );
	
}

private static final String _lineSeparator = Failure.lineSeparator;


}//MsgTest