package multex;  //MsgTextTest.java

import java.util.Locale;

import multex.test.MsgTextDeResourceBundle;
import multex.test.NotextException3Chain;

//2003-05-08  Knabe  Aus Vorlage MsgTest
//2002-05-30  Knabe  Umbau von Stack_bt gem Beispiel junit.samples.VectorTest

/**JUnit batch test driver for the class multex.MsgText.
*/
public class MsgTextTest extends junit.framework.TestCase {


//Verwaltungsoperationen:

public MsgTextTest(String name) {
  super(name);
}
public static void main (String[] args) {
  junit.textui.TestRunner.run(suite());
}
public static junit.framework.Test suite() {
  final junit.framework.TestSuite result
  = new junit.framework.TestSuite(MsgTextTest.class);
  return result;
}

//Einzelne Testschritte:

private static final String    _ex2Par = "MyClass";
private static final Exception _ex2    = new ClassCastException(_ex2Par);
private static final String    _ex2Name = "java.lang.ClassCastException";
private static final Exception _ex1 = new multex.test.InitFailure(_ex2, "OOO", 9999);
private static final String    _ex1Name = "multex.test.InitFailure";
private static final String ursachenMarkierer = "CAUSE: ";
private static final MultexLocale _locale 
= new MultexLocale(new multex.test.MsgTextDeResourceBundle(), null, ursachenMarkierer);

public void testGetMessageTextPattern_withoutAnyTexts(){
	final Throwable ex1 = NotextException3Chain.construct();

	final String result1 = MsgText.getMessageTextPattern(ex1);
	assertEquals(NotextException3Chain.ex1Name, result1);
	
	final String result2 = MsgText.getMessageTextPattern(ex1.getCause());
	assertEquals(NotextException3Chain.ex2Name, result2);
	
	final String result3 = MsgText.getMessageTextPattern(ex1.getCause().getCause());
	assertEquals(NotextException3Chain.ex3Name, result3);
}

public void testGetMessageTextPattern_withLocale(){
	final String result1 = MsgText.getMessageTextPattern(_ex2, _locale);
	assertEquals(multex.test.MsgTextDeResourceBundle.classCastExceptionText, result1);
	
	final String result2 = MsgText.getMessageTextPattern(_ex1, _locale);
	assertEquals(MsgTextDeResourceBundle.initFailureText, result2);
}

public void testAppendMessageLineWithDefaultLocale(){

	final StringBuffer result2 = new StringBuffer();
	MsgText.appendMessageLine(result2, _ex2, _locale);
	assertEquals(
	    multex.test.MsgTextDeResourceBundle.classCastExceptionText
	    + ": " + _ex2Par, 
	    result2.toString()
	);

}

public void testAppendMessageLineWithLocales(){
	
	final StringBuffer result = new StringBuffer();
	MsgText.appendMessageLine(result, _ex1, _locale);
	assertEquals(
	    "Man kann mit Wert 9.999 nicht Objekt OOO initialisieren", 
	    result.toString()
	);

	result.setLength(0);
	MsgText.appendMessageLine(result, _ex1, new MultexLocale(new multex.test.MsgTextDeResourceBundle(), Locale.ENGLISH, ursachenMarkierer));
	assertEquals(
	    "Man kann mit Wert 9,999 nicht Objekt OOO initialisieren", 
	    result.toString()
	);

}


}//MsgTextTest