package multex.test;

/**
 * Chain of 3 exceptions for test purposes.
 * 
 * @author Christoph Knabe  2003-05-21
 */
public class NotextException3Chain {

/*package*/	static class MainFailure extends multex.Failure {
	MainFailure(final Throwable i_cause, final long i_long, final double i_float){
		super(null, i_cause, new Long(i_long), new Double(i_float));
	}
}
	
/*package*/	static class MidFailure extends multex.Failure {
	MidFailure(final Throwable i_cause){super(null, i_cause);}
}

public static final String ex1Name = new MainFailure(null,0,0.0).getClass().getName();
public static final String ex2Name = new MidFailure(null).getClass().getName();
public static final String ex3Name = new ClassCastException().getClass().getName();
public static final String ex3Param = "MyClass";
public static final String ex3Message = ex3Name + ": " + ex3Param;


/**Constructs a chain of the 3 exceptions: 
 * multex.test.InitFailure, multex.Failure, ClassCastException
*/
public static Throwable construct(){
	
	final Throwable ex3 = new ClassCastException(ex3Param);
	final MidFailure ex2 = new MidFailure(ex3);
	final MainFailure ex1 = new MainFailure(ex2, 9999, 3.14);
	return ex1;
}


}
